##// END OF EJS Templates
Sugesstion...
Unknown -
r284:b3abfe40eca8
parent child
Show More
@@ -1,774 +1,765
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49
50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53
54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57
58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61
62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65
66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69
70 # Debian release
46 # Debian release
71 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=buster}
72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 fi
80
81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 else
86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 fi
91
48
92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
49 #Kernel Branch
93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
50 KERNEL_BRANCH=${KERNEL_BRANCH:="rpi-4.14.y"}
94 else
95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 fi
97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98
51
99 # URLs
52 # URLs
100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106
59
107 # Build directories
60 # Build directories
108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
110
63
111 # Prepare date string for default image file name
64 # Prepare date string for default image file name
112 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
113 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 else
68 else
116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 fi
70 fi
118
71
119 # Chroot directories
72 # Chroot directories
120 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
121 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
122 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
123 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
124 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126
79
127 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129
82
130 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
137
91
138 # Keyboard settings
92 # Keyboard settings
139 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
140 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
142 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
143
97
144 # Network settings (DHCP)
98 # Network settings (DHCP)
145 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
146
100
147 # Network settings (static)
101 # Network settings (static)
148 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
149 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
150 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
151 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
154 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
155
109
156 # APT settings
110 # APT settings
157 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159
113
160 # Feature settings
114 # Feature settings
161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
163 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
164 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
173 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
176 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
177 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
179
133
180 # SSH settings
134 # SSH settings
181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186
140
187 # Advanced settings
141 # Advanced settings
188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200
154
201 # Kernel compilation settings
155 # Kernel compilation settings
202 BUILD_KERNEL=${BUILD_KERNEL:=false}
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210
164
211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 else
214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 fi
216
217 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222
170
223 # Reduce disk usage settings
171 # Reduce disk usage settings
224 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
225 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
226 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
227 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
228 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
229 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232
180
233 # Encrypted filesystem settings
181 # Encrypted filesystem settings
234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239
187
240 # Chroot scripts directory
188 # Chroot scripts directory
241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242
190
243 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
244 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246
194
247 # Packages required for bootstrapping
195 # Packages required for bootstrapping
248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
250
198
251 # Packages installed for c/c++ build environment in chroot (keep empty)
199 # Packages installed for c/c++ build environment in chroot (keep empty)
252 COMPILER_PACKAGES=""
200 COMPILER_PACKAGES=""
253
201
254 set +x
202 set +x
255
203
256 # Set Raspberry Pi model specific configuration
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 if [ "$RPI_MODEL" = 0 ] ; then
205 if [ -n "$SET_ARCH" ]
258 DTB_FILE=${RPI0_DTB_FILE}
206 echo "Setting Architecture specific settings"
259 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
207 ##################################
260 elif [ "$RPI_MODEL" = 1 ] ; then
208 # 64 bit config
261 DTB_FILE=${RPI1_DTB_FILE}
209 ##################################
262 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
263 elif [ "$RPI_MODEL" = 1P ] ; then
211 echo "64 bit mode selected - Setting up enviroment"
264 DTB_FILE=${RPI1P_DTB_FILE}
212 # 64 bit depended settings
265 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
266 elif [ "$RPI_MODEL" = 2 ] ; then
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
267 DTB_FILE=${RPI2_DTB_FILE}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
269 elif [ "$RPI_MODEL" = 3 ] ; then
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
270 DTB_FILE=${RPI3_DTB_FILE}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
219
272 elif [ "$RPI_MODEL" = 3P ] ; then
220 # RPI 3 serie specific settings
273 DTB_FILE=${RPI3P_DTB_FILE}
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
274 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
275 else
226 else
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 exit 1
229 fi
230
231 ##################################
232 # 32 bit config
233 ##################################
234 if [ "$SET_ARCH" = 32 ] ; then
235 echo "32 bit mode selected - Setting up enviroment"
236 #General 32bit configuration
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240
241 #Raspberry setting grouped by board compability
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 elif [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
250 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
251 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
252 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
253 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
254 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
255 fi
256
257 #Device specific configuration
258 case "$RPI_MODEL" in
259 0)
260 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
261 1)
262 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
263 1P)
264 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
265 2)
266 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
267 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
268 #Precompiled Kernel rpi2
269 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
270 ;;
271 3)
272 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
273 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
274 ;;
275 3P
276 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
277 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
278 ;;
279 *)
276 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
280 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
277 exit 1
281 exit 1
282 ;;
283 esac
284 fi
285 else
286 echo "error: Please set '32' or '64' as value for SET_ARCH"
287 exit 1
278 fi
288 fi
279
289
280 # Check if the internal wireless interface is supported by the RPi model
290 # Check if the internal wireless interface is supported by the RPi model
281 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
291 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
282
283 echo "error: The selected Raspberry Pi model has no internal wireless interface"
292 echo "error: The selected Raspberry Pi model has no internal wireless interface"
284 exit 1
293 exit 1
294 else
295 echo "Raspberry Pi model"
285 fi
296 fi
286
297
287 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
298 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
288 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
299 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
289 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
300 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
290 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
301 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
291 exit 1
302 exit 1
292 fi
303 fi
293 fi
304 fi
294
305
295 # Build RPi2/3 Linux kernel if required by Debian release
296 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
297 BUILD_KERNEL=true
298 fi
299
300 # Add packages required for kernel cross compilation
301 if [ "$BUILD_KERNEL" = true ] ; then
302 if [ "$KERNEL_ARCH" = "arm" ] ; then
303 if [ "$RELEASE_ARCH" = "armel" ]; then
304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
305 fi
306 if [ "$RELEASE_ARCH" = "armhf" ]; then
307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
308 fi
309 if [ "$RELEASE_ARCH" = "arm64" ]; then
310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
311 fi
312 fi
313 fi
314
315 # Add libncurses5 to enable kernel menuconfig
306 # Add libncurses5 to enable kernel menuconfig
316 if [ "$KERNEL_MENUCONFIG" = true ] ; then
307 if [ "$KERNEL_MENUCONFIG" = true ] ; then
317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
318 fi
309 fi
319
310
320 # Add ccache compiler cache for (faster) kernel cross (re)compilation
311 # Add ccache compiler cache for (faster) kernel cross (re)compilation
321 if [ "$KERNEL_CCACHE" = true ] ; then
312 if [ "$KERNEL_CCACHE" = true ] ; then
322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
323 fi
314 fi
324
315
325 # Add cryptsetup package to enable filesystem encryption
316 # Add cryptsetup package to enable filesystem encryption
326 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
317 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
327 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
328 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
319 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
329
320
330 if [ -z "$CRYPTFS_PASSWORD" ] ; then
321 if [ -z "$CRYPTFS_PASSWORD" ] ; then
331 echo "error: no password defined (CRYPTFS_PASSWORD)!"
322 echo "error: no password defined (CRYPTFS_PASSWORD)!"
332 exit 1
323 exit 1
333 fi
324 fi
334 ENABLE_INITRAMFS=true
325 ENABLE_INITRAMFS=true
335 fi
326 fi
336
327
337 # Add initramfs generation tools
328 # Add initramfs generation tools
338 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
329 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
339 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
330 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
340 fi
331 fi
341
332
342 # Add device-tree-compiler required for building the U-Boot bootloader
333 # Add device-tree-compiler required for building the U-Boot bootloader
343 if [ "$ENABLE_UBOOT" = true ] ; then
334 if [ "$ENABLE_UBOOT" = true ] ; then
344 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
335 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
345 fi
336 fi
346
337
347 # Check if root SSH (v2) public key file exists
338 # Check if root SSH (v2) public key file exists
348 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
339 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
349 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
340 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
350 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
341 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
351 exit 1
342 exit 1
352 fi
343 fi
353 fi
344 fi
354
345
355 # Check if $USER_NAME SSH (v2) public key file exists
346 # Check if $USER_NAME SSH (v2) public key file exists
356 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
347 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
357 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
348 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
358 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
349 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
359 exit 1
350 exit 1
360 fi
351 fi
361 fi
352 fi
362
353
363 # Check if all required packages are installed on the build system
354 # Check if all required packages are installed on the build system
364 for package in $REQUIRED_PACKAGES ; do
355 for package in $REQUIRED_PACKAGES ; do
365 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
356 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
366 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
357 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
367 fi
358 fi
368 done
359 done
369
360
370 # If there are missing packages ask confirmation for install, or exit
361 # If there are missing packages ask confirmation for install, or exit
371 if [ -n "$MISSING_PACKAGES" ] ; then
362 if [ -n "$MISSING_PACKAGES" ] ; then
372 echo "the following packages needed by this script are not installed:"
363 echo "the following packages needed by this script are not installed:"
373 echo "$MISSING_PACKAGES"
364 echo "$MISSING_PACKAGES"
374
365
375 echo -n "\ndo you want to install the missing packages right now? [y/n] "
366 echo -n "\ndo you want to install the missing packages right now? [y/n] "
376 read confirm
367 read confirm
377 [ "$confirm" != "y" ] && exit 1
368 [ "$confirm" != "y" ] && exit 1
378
369
379 # Make sure all missing required packages are installed
370 # Make sure all missing required packages are installed
380 apt-get -qq -y install ${MISSING_PACKAGES}
371 apt-get -qq -y install ${MISSING_PACKAGES}
381 fi
372 fi
382
373
383 # Check if ./bootstrap.d directory exists
374 # Check if ./bootstrap.d directory exists
384 if [ ! -d "./bootstrap.d/" ] ; then
375 if [ ! -d "./bootstrap.d/" ] ; then
385 echo "error: './bootstrap.d' required directory not found!"
376 echo "error: './bootstrap.d' required directory not found!"
386 exit 1
377 exit 1
387 fi
378 fi
388
379
389 # Check if ./files directory exists
380 # Check if ./files directory exists
390 if [ ! -d "./files/" ] ; then
381 if [ ! -d "./files/" ] ; then
391 echo "error: './files' required directory not found!"
382 echo "error: './files' required directory not found!"
392 exit 1
383 exit 1
393 fi
384 fi
394
385
395 # Check if specified KERNELSRC_DIR directory exists
386 # Check if specified KERNELSRC_DIR directory exists
396 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
387 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
397 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
388 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
398 exit 1
389 exit 1
399 fi
390 fi
400
391
401 # Check if specified UBOOTSRC_DIR directory exists
392 # Check if specified UBOOTSRC_DIR directory exists
402 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
393 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
403 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
394 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
404 exit 1
395 exit 1
405 fi
396 fi
406
397
407 # Check if specified FBTURBOSRC_DIR directory exists
398 # Check if specified FBTURBOSRC_DIR directory exists
408 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
399 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
409 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
400 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
410 exit 1
401 exit 1
411 fi
402 fi
412
403
413 # Check if specified CHROOT_SCRIPTS directory exists
404 # Check if specified CHROOT_SCRIPTS directory exists
414 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
405 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
415 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
406 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
416 exit 1
407 exit 1
417 fi
408 fi
418
409
419 # Check if specified device mapping already exists (will be used by cryptsetup)
410 # Check if specified device mapping already exists (will be used by cryptsetup)
420 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
411 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
421 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
412 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
422 exit 1
413 exit 1
423 fi
414 fi
424
415
425 # Don't clobber an old build
416 # Don't clobber an old build
426 if [ -e "$BUILDDIR" ] ; then
417 if [ -e "$BUILDDIR" ] ; then
427 echo "error: directory ${BUILDDIR} already exists, not proceeding"
418 echo "error: directory ${BUILDDIR} already exists, not proceeding"
428 exit 1
419 exit 1
429 fi
420 fi
430
421
431 # Setup chroot directory
422 # Setup chroot directory
432 mkdir -p "${R}"
423 mkdir -p "${R}"
433
424
434 # Check if build directory has enough of free disk space >512MB
425 # Check if build directory has enough of free disk space >512MB
435 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
426 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
436 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
427 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
437 exit 1
428 exit 1
438 fi
429 fi
439
430
440 set -x
431 set -x
441
432
442 # Call "cleanup" function on various signals and errors
433 # Call "cleanup" function on various signals and errors
443 trap cleanup 0 1 2 3 6
434 trap cleanup 0 1 2 3 6
444
435
445 # Add required packages for the minbase installation
436 # Add required packages for the minbase installation
446 if [ "$ENABLE_MINBASE" = true ] ; then
437 if [ "$ENABLE_MINBASE" = true ] ; then
447 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
438 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
448 fi
439 fi
449
440
450 # Add required locales packages
441 # Add required locales packages
451 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
442 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
452 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
443 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
453 fi
444 fi
454
445
455 # Add parted package, required to get partprobe utility
446 # Add parted package, required to get partprobe utility
456 if [ "$EXPANDROOT" = true ] ; then
447 if [ "$EXPANDROOT" = true ] ; then
457 APT_INCLUDES="${APT_INCLUDES},parted"
448 APT_INCLUDES="${APT_INCLUDES},parted"
458 fi
449 fi
459
450
460 # Add dbus package, recommended if using systemd
451 # Add dbus package, recommended if using systemd
461 if [ "$ENABLE_DBUS" = true ] ; then
452 if [ "$ENABLE_DBUS" = true ] ; then
462 APT_INCLUDES="${APT_INCLUDES},dbus"
453 APT_INCLUDES="${APT_INCLUDES},dbus"
463 fi
454 fi
464
455
465 # Add iptables IPv4/IPv6 package
456 # Add iptables IPv4/IPv6 package
466 if [ "$ENABLE_IPTABLES" = true ] ; then
457 if [ "$ENABLE_IPTABLES" = true ] ; then
467 APT_INCLUDES="${APT_INCLUDES},iptables"
458 APT_INCLUDES="${APT_INCLUDES},iptables"
468 fi
459 fi
469
460
470 # Add openssh server package
461 # Add openssh server package
471 if [ "$ENABLE_SSHD" = true ] ; then
462 if [ "$ENABLE_SSHD" = true ] ; then
472 APT_INCLUDES="${APT_INCLUDES},openssh-server"
463 APT_INCLUDES="${APT_INCLUDES},openssh-server"
473 fi
464 fi
474
465
475 # Add alsa-utils package
466 # Add alsa-utils package
476 if [ "$ENABLE_SOUND" = true ] ; then
467 if [ "$ENABLE_SOUND" = true ] ; then
477 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
468 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
478 fi
469 fi
479
470
480 # Add rng-tools package
471 # Add rng-tools package
481 if [ "$ENABLE_HWRANDOM" = true ] ; then
472 if [ "$ENABLE_HWRANDOM" = true ] ; then
482 APT_INCLUDES="${APT_INCLUDES},rng-tools"
473 APT_INCLUDES="${APT_INCLUDES},rng-tools"
483 fi
474 fi
484
475
485 # Add fbturbo video driver
476 # Add fbturbo video driver
486 if [ "$ENABLE_FBTURBO" = true ] ; then
477 if [ "$ENABLE_FBTURBO" = true ] ; then
487 # Enable xorg package dependencies
478 # Enable xorg package dependencies
488 ENABLE_XORG=true
479 ENABLE_XORG=true
489 fi
480 fi
490
481
491 # Add user defined window manager package
482 # Add user defined window manager package
492 if [ -n "$ENABLE_WM" ] ; then
483 if [ -n "$ENABLE_WM" ] ; then
493 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
484 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
494
485
495 # Enable xorg package dependencies
486 # Enable xorg package dependencies
496 ENABLE_XORG=true
487 ENABLE_XORG=true
497 fi
488 fi
498
489
499 # Add xorg package
490 # Add xorg package
500 if [ "$ENABLE_XORG" = true ] ; then
491 if [ "$ENABLE_XORG" = true ] ; then
501 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
492 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
502 fi
493 fi
503
494
504 # Replace selected packages with smaller clones
495 # Replace selected packages with smaller clones
505 if [ "$ENABLE_REDUCE" = true ] ; then
496 if [ "$ENABLE_REDUCE" = true ] ; then
506 # Add levee package instead of vim-tiny
497 # Add levee package instead of vim-tiny
507 if [ "$REDUCE_VIM" = true ] ; then
498 if [ "$REDUCE_VIM" = true ] ; then
508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
499 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
509 fi
500 fi
510
501
511 # Add dropbear package instead of openssh-server
502 # Add dropbear package instead of openssh-server
512 if [ "$REDUCE_SSHD" = true ] ; then
503 if [ "$REDUCE_SSHD" = true ] ; then
513 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
514 fi
505 fi
515 fi
506 fi
516
507
517 if [ "$RELEASE" != "jessie" ] ; then
508 if [ "$RELEASE" != "jessie" ] ; then
518 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
509 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
519 fi
510 fi
520
511
521 # Configure kernel sources if no KERNELSRC_DIR
512 # Configure kernel sources if no KERNELSRC_DIR
522 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
513 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
523 KERNELSRC_CONFIG=true
514 KERNELSRC_CONFIG=true
524 fi
515 fi
525
516
526 # Configure reduced kernel
517 # Configure reduced kernel
527 if [ "$KERNEL_REDUCE" = true ] ; then
518 if [ "$KERNEL_REDUCE" = true ] ; then
528 KERNELSRC_CONFIG=false
519 KERNELSRC_CONFIG=false
529 fi
520 fi
530
521
531 # Configure qemu compatible kernel
522 # Configure qemu compatible kernel
532 if [ "$ENABLE_QEMU" = true ] ; then
523 if [ "$ENABLE_QEMU" = true ] ; then
533 DTB_FILE=vexpress-v2p-ca15_a7.dtb
524 DTB_FILE=vexpress-v2p-ca15_a7.dtb
534 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
525 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
535 KERNEL_DEFCONFIG="vexpress_defconfig"
526 KERNEL_DEFCONFIG="vexpress_defconfig"
536 if [ "$KERNEL_MENUCONFIG" = false ] ; then
527 if [ "$KERNEL_MENUCONFIG" = false ] ; then
537 KERNEL_OLDDEFCONFIG=true
528 KERNEL_OLDDEFCONFIG=true
538 fi
529 fi
539 fi
530 fi
540
531
541 # Execute bootstrap scripts
532 # Execute bootstrap scripts
542 for SCRIPT in bootstrap.d/*.sh; do
533 for SCRIPT in bootstrap.d/*.sh; do
543 head -n 3 "$SCRIPT"
534 head -n 3 "$SCRIPT"
544 . "$SCRIPT"
535 . "$SCRIPT"
545 done
536 done
546
537
547 ## Execute custom bootstrap scripts
538 ## Execute custom bootstrap scripts
548 if [ -d "custom.d" ] ; then
539 if [ -d "custom.d" ] ; then
549 for SCRIPT in custom.d/*.sh; do
540 for SCRIPT in custom.d/*.sh; do
550 . "$SCRIPT"
541 . "$SCRIPT"
551 done
542 done
552 fi
543 fi
553
544
554 # Execute custom scripts inside the chroot
545 # Execute custom scripts inside the chroot
555 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
546 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
556 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
547 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
557 chroot_exec /bin/bash -x <<'EOF'
548 chroot_exec /bin/bash -x <<'EOF'
558 for SCRIPT in /chroot_scripts/* ; do
549 for SCRIPT in /chroot_scripts/* ; do
559 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
550 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
560 $SCRIPT
551 $SCRIPT
561 fi
552 fi
562 done
553 done
563 EOF
554 EOF
564 rm -rf "${R}/chroot_scripts"
555 rm -rf "${R}/chroot_scripts"
565 fi
556 fi
566
557
567 # Remove c/c++ build environment from the chroot
558 # Remove c/c++ build environment from the chroot
568 chroot_remove_cc
559 chroot_remove_cc
569
560
570 # Remove apt-utils
561 # Remove apt-utils
571 if [ "$RELEASE" = "jessie" ] ; then
562 if [ "$RELEASE" = "jessie" ] ; then
572 chroot_exec apt-get purge -qq -y --force-yes apt-utils
563 chroot_exec apt-get purge -qq -y --force-yes apt-utils
573 fi
564 fi
574
565
575 # Generate required machine-id
566 # Generate required machine-id
576 MACHINE_ID=$(dbus-uuidgen)
567 MACHINE_ID=$(dbus-uuidgen)
577 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
568 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
578 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
569 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
579
570
580 # APT Cleanup
571 # APT Cleanup
581 chroot_exec apt-get -y clean
572 chroot_exec apt-get -y clean
582 chroot_exec apt-get -y autoclean
573 chroot_exec apt-get -y autoclean
583 chroot_exec apt-get -y autoremove
574 chroot_exec apt-get -y autoremove
584
575
585 # Unmount mounted filesystems
576 # Unmount mounted filesystems
586 umount -l "${R}/proc"
577 umount -l "${R}/proc"
587 umount -l "${R}/sys"
578 umount -l "${R}/sys"
588
579
589 # Clean up directories
580 # Clean up directories
590 rm -rf "${R}/run/*"
581 rm -rf "${R}/run/*"
591 rm -rf "${R}/tmp/*"
582 rm -rf "${R}/tmp/*"
592
583
593 # Clean up files
584 # Clean up files
594 rm -f "${ETC_DIR}/ssh/ssh_host_*"
585 rm -f "${ETC_DIR}/ssh/ssh_host_*"
595 rm -f "${ETC_DIR}/dropbear/dropbear_*"
586 rm -f "${ETC_DIR}/dropbear/dropbear_*"
596 rm -f "${ETC_DIR}/apt/sources.list.save"
587 rm -f "${ETC_DIR}/apt/sources.list.save"
597 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
588 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
598 rm -f "${ETC_DIR}/*-"
589 rm -f "${ETC_DIR}/*-"
599 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
590 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
600 rm -f "${ETC_DIR}/resolv.conf"
591 rm -f "${ETC_DIR}/resolv.conf"
601 rm -f "${R}/root/.bash_history"
592 rm -f "${R}/root/.bash_history"
602 rm -f "${R}/var/lib/urandom/random-seed"
593 rm -f "${R}/var/lib/urandom/random-seed"
603 rm -f "${R}/initrd.img"
594 rm -f "${R}/initrd.img"
604 rm -f "${R}/vmlinuz"
595 rm -f "${R}/vmlinuz"
605 rm -f "${R}${QEMU_BINARY}"
596 rm -f "${R}${QEMU_BINARY}"
606
597
607 if [ "$ENABLE_QEMU" = true ] ; then
598 if [ "$ENABLE_QEMU" = true ] ; then
608 # Setup QEMU directory
599 # Setup QEMU directory
609 mkdir "${BASEDIR}/qemu"
600 mkdir "${BASEDIR}/qemu"
610
601
611 # Copy kernel image to QEMU directory
602 # Copy kernel image to QEMU directory
612 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
603 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
613
604
614 # Copy kernel config to QEMU directory
605 # Copy kernel config to QEMU directory
615 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
606 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
616
607
617 # Copy kernel dtbs to QEMU directory
608 # Copy kernel dtbs to QEMU directory
618 for dtb in "${BOOT_DIR}/"*.dtb ; do
609 for dtb in "${BOOT_DIR}/"*.dtb ; do
619 if [ -f "${dtb}" ] ; then
610 if [ -f "${dtb}" ] ; then
620 install_readonly "${dtb}" "${BASEDIR}/qemu/"
611 install_readonly "${dtb}" "${BASEDIR}/qemu/"
621 fi
612 fi
622 done
613 done
623
614
624 # Copy kernel overlays to QEMU directory
615 # Copy kernel overlays to QEMU directory
625 if [ -d "${BOOT_DIR}/overlays" ] ; then
616 if [ -d "${BOOT_DIR}/overlays" ] ; then
626 # Setup overlays dtbs directory
617 # Setup overlays dtbs directory
627 mkdir "${BASEDIR}/qemu/overlays"
618 mkdir "${BASEDIR}/qemu/overlays"
628
619
629 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
620 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
630 if [ -f "${dtb}" ] ; then
621 if [ -f "${dtb}" ] ; then
631 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
622 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
632 fi
623 fi
633 done
624 done
634 fi
625 fi
635
626
636 # Copy u-boot files to QEMU directory
627 # Copy u-boot files to QEMU directory
637 if [ "$ENABLE_UBOOT" = true ] ; then
628 if [ "$ENABLE_UBOOT" = true ] ; then
638 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
629 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
639 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
630 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
640 fi
631 fi
641 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
632 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
642 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
633 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
643 fi
634 fi
644 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
635 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
645 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
636 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
646 fi
637 fi
647 fi
638 fi
648
639
649 # Copy initramfs to QEMU directory
640 # Copy initramfs to QEMU directory
650 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
641 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
651 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
642 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
652 fi
643 fi
653 fi
644 fi
654
645
655 # Calculate size of the chroot directory in KB
646 # Calculate size of the chroot directory in KB
656 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
647 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
657
648
658 # Calculate the amount of needed 512 Byte sectors
649 # Calculate the amount of needed 512 Byte sectors
659 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
650 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
660 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
651 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
661 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
652 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
662
653
663 # The root partition is EXT4
654 # The root partition is EXT4
664 # This means more space than the actual used space of the chroot is used.
655 # This means more space than the actual used space of the chroot is used.
665 # As overhead for journaling and reserved blocks 35% are added.
656 # As overhead for journaling and reserved blocks 35% are added.
666 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
657 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
667
658
668 # Calculate required image size in 512 Byte sectors
659 # Calculate required image size in 512 Byte sectors
669 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
660 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
670
661
671 # Prepare image file
662 # Prepare image file
672 if [ "$ENABLE_SPLITFS" = true ] ; then
663 if [ "$ENABLE_SPLITFS" = true ] ; then
673 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
664 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
674 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
675 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
666 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
676 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
667 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
677
668
678 # Write firmware/boot partition tables
669 # Write firmware/boot partition tables
679 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
670 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
680 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
671 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
681 EOM
672 EOM
682
673
683 # Write root partition table
674 # Write root partition table
684 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
675 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
685 ${TABLE_SECTORS},${ROOT_SECTORS},83
676 ${TABLE_SECTORS},${ROOT_SECTORS},83
686 EOM
677 EOM
687
678
688 # Setup temporary loop devices
679 # Setup temporary loop devices
689 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
680 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
690 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
681 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
691 else # ENABLE_SPLITFS=false
682 else # ENABLE_SPLITFS=false
692 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
683 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
693 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
684 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
694
685
695 # Write partition table
686 # Write partition table
696 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
687 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
697 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
688 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
698 ${ROOT_OFFSET},${ROOT_SECTORS},83
689 ${ROOT_OFFSET},${ROOT_SECTORS},83
699 EOM
690 EOM
700
691
701 # Setup temporary loop devices
692 # Setup temporary loop devices
702 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
693 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
703 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
694 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
704 fi
695 fi
705
696
706 if [ "$ENABLE_CRYPTFS" = true ] ; then
697 if [ "$ENABLE_CRYPTFS" = true ] ; then
707 # Create dummy ext4 fs
698 # Create dummy ext4 fs
708 mkfs.ext4 "$ROOT_LOOP"
699 mkfs.ext4 "$ROOT_LOOP"
709
700
710 # Setup password keyfile
701 # Setup password keyfile
711 touch .password
702 touch .password
712 chmod 600 .password
703 chmod 600 .password
713 echo -n ${CRYPTFS_PASSWORD} > .password
704 echo -n ${CRYPTFS_PASSWORD} > .password
714
705
715 # Initialize encrypted partition
706 # Initialize encrypted partition
716 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
707 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
717
708
718 # Open encrypted partition and setup mapping
709 # Open encrypted partition and setup mapping
719 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
710 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
720
711
721 # Secure delete password keyfile
712 # Secure delete password keyfile
722 shred -zu .password
713 shred -zu .password
723
714
724 # Update temporary loop device
715 # Update temporary loop device
725 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
716 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
726
717
727 # Wipe encrypted partition (encryption cipher is used for randomness)
718 # Wipe encrypted partition (encryption cipher is used for randomness)
728 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
719 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
729 fi
720 fi
730
721
731 # Build filesystems
722 # Build filesystems
732 mkfs.vfat "$FRMW_LOOP"
723 mkfs.vfat "$FRMW_LOOP"
733 mkfs.ext4 "$ROOT_LOOP"
724 mkfs.ext4 "$ROOT_LOOP"
734
725
735 # Mount the temporary loop devices
726 # Mount the temporary loop devices
736 mkdir -p "$BUILDDIR/mount"
727 mkdir -p "$BUILDDIR/mount"
737 mount "$ROOT_LOOP" "$BUILDDIR/mount"
728 mount "$ROOT_LOOP" "$BUILDDIR/mount"
738
729
739 mkdir -p "$BUILDDIR/mount/boot/firmware"
730 mkdir -p "$BUILDDIR/mount/boot/firmware"
740 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
731 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
741
732
742 # Copy all files from the chroot to the loop device mount point directory
733 # Copy all files from the chroot to the loop device mount point directory
743 rsync -a "${R}/" "$BUILDDIR/mount/"
734 rsync -a "${R}/" "$BUILDDIR/mount/"
744
735
745 # Unmount all temporary loop devices and mount points
736 # Unmount all temporary loop devices and mount points
746 cleanup
737 cleanup
747
738
748 # Create block map file(s) of image(s)
739 # Create block map file(s) of image(s)
749 if [ "$ENABLE_SPLITFS" = true ] ; then
740 if [ "$ENABLE_SPLITFS" = true ] ; then
750 # Create block map files for "bmaptool"
741 # Create block map files for "bmaptool"
751 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
742 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
752 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
743 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
753
744
754 # Image was successfully created
745 # Image was successfully created
755 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
746 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
756 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
747 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
757 else
748 else
758 # Create block map file for "bmaptool"
749 # Create block map file for "bmaptool"
759 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
750 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
760
751
761 # Image was successfully created
752 # Image was successfully created
762 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
753 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
763
754
764 # Create qemu qcow2 image
755 # Create qemu qcow2 image
765 if [ "$ENABLE_QEMU" = true ] ; then
756 if [ "$ENABLE_QEMU" = true ] ; then
766 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
757 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
767 QEMU_SIZE=16G
758 QEMU_SIZE=16G
768
759
769 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
760 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
770 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
761 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
771
762
772 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
763 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
773 fi
764 fi
774 fi
765 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant